VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cLogicalDrives"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Clase para obtener las letras de las unidades lgicas presentes en el sistema.El mtodo UnidadesExistentes devuelve un string con las que cumplan con las condiciones establecidas mediante las propiedades UnidadesXXXX."
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'variables locales que contienen valores de propiedad
Private mvarUnidadesRemovibles As Boolean 'copia local
Private mvarUnidadesFijas As Boolean 'copia local
Private mvarUnidadesRemotas As Boolean 'copia local
Private mvarUnidadesCDRom As Boolean 'copia local
Private mvarUnidadesEnMemoria As Boolean 'copia local
'para saber que tipos de unidades solicitan
Private TipoUnidad(2 To 6) As Boolean
'declaraciones del API
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6


Public Function UnidadesExistentes() As String
Attribute UnidadesExistentes.VB_UserMemId = 0
Dim r As Long, allDrives As String, aux As String, i As Long
Dim JustOneDrive As String, pos As Long, DriveType As Long

allDrives = Space$(64)
r = GetLogicalDriveStrings(Len(allDrives), allDrives)
aux = ""
allDrives = Left$(allDrives, r)
Do
    pos = InStr(allDrives, Chr$(0))
    If pos Then
        JustOneDrive = Left$(allDrives, pos)
        allDrives$ = Mid$(allDrives, pos + 1, Len(allDrives))
        DriveType = GetDriveType(JustOneDrive)
        If TipoUnidad(DriveType) Then aux = aux + UCase$(Left$(JustOneDrive, 1))
    End If
Loop Until allDrives = ""
UnidadesExistentes = aux
End Function

Public Property Let UnidadesEnMemoria(ByVal vData As Boolean)
Attribute UnidadesEnMemoria.VB_Description = "Indica si queremos incluir en el listado de unidades los discos en memoria (RAM Disk)"
'se usa cuando se asigna un valor a una propiedad, en el lado izquierdo de la asignacin.
'Syntax: X.UnidadesEnMemoria = 5
    mvarUnidadesEnMemoria = vData
    TipoUnidad(DRIVE_RAMDISK) = vData
End Property


Public Property Get UnidadesEnMemoria() As Boolean
'se usa cuando se asigna un valor a una propiedad, en el lado derecho de la asignacin.
'Syntax: Debug.Print X.UnidadesEnMemoria
    UnidadesEnMemoria = mvarUnidadesEnMemoria
End Property



Public Property Let UnidadesCDRom(ByVal vData As Boolean)
Attribute UnidadesCDRom.VB_Description = "Indica si queremos incluir en el listado de unidades las de cd-rom"
'se usa cuando se asigna un valor a una propiedad, en el lado izquierdo de la asignacin.
'Syntax: X.UnidadesCDRom = 5
    mvarUnidadesCDRom = vData
    TipoUnidad(DRIVE_CDROM) = vData
End Property


Public Property Get UnidadesCDRom() As Boolean
'se usa cuando se asigna un valor a una propiedad, en el lado derecho de la asignacin.
'Syntax: Debug.Print X.UnidadesCDRom
    UnidadesCDRom = mvarUnidadesCDRom
End Property



Public Property Let UnidadesRemotas(ByVal vData As Boolean)
Attribute UnidadesRemotas.VB_Description = "Indica si queremos incluir en el listado de unidades las unidades de red"
'se usa cuando se asigna un valor a una propiedad, en el lado izquierdo de la asignacin.
'Syntax: X.UnidadesRemotas = 5
    mvarUnidadesRemotas = vData
    TipoUnidad(DRIVE_REMOTE) = vData
End Property


Public Property Get UnidadesRemotas() As Boolean
'se usa cuando se asigna un valor a una propiedad, en el lado derecho de la asignacin.
'Syntax: Debug.Print X.UnidadesRemotas
    UnidadesRemotas = mvarUnidadesRemotas
End Property



Public Property Let UnidadesFijas(ByVal vData As Boolean)
Attribute UnidadesFijas.VB_Description = "Indica si queremos incluir en el listado de unidades los discos duros"
'se usa cuando se asigna un valor a una propiedad, en el lado izquierdo de la asignacin.
'Syntax: X.UnidadesFijas = 5
    mvarUnidadesFijas = vData
    TipoUnidad(DRIVE_FIXED) = vData
End Property


Public Property Get UnidadesFijas() As Boolean
'se usa cuando se asigna un valor a una propiedad, en el lado derecho de la asignacin.
'Syntax: Debug.Print X.UnidadesFijas
    UnidadesFijas = mvarUnidadesFijas
End Property



Public Property Let UnidadesRemovibles(ByVal vData As Boolean)
Attribute UnidadesRemovibles.VB_Description = "Indica si queremos incluir en el listado de unidades las removibles (disquetes y otras unidades removibles)"
'se usa cuando se asigna un valor a una propiedad, en el lado izquierdo de la asignacin.
'Syntax: X.UnidadesRemovibles = 5
    mvarUnidadesRemovibles = vData
    TipoUnidad(DRIVE_REMOVABLE) = vData
End Property


Public Property Get UnidadesRemovibles() As Boolean
'se usa cuando se asigna un valor a una propiedad, en el lado derecho de la asignacin.
'Syntax: Debug.Print X.UnidadesRemovibles
    UnidadesRemovibles = mvarUnidadesRemovibles
End Property



Private Sub Class_Initialize()
UnidadesCDRom = True
UnidadesEnMemoria = True
UnidadesFijas = True
UnidadesRemotas = True
UnidadesRemovibles = True
End Sub


